!!ARBfp1.0

#standard lighting with normal mapping and per pixel attenuation
#Author: Rich Whitehouse
#---------------------------------------------------------------------

#this has become somewhat of a mess.
#texture0 is the decal
#texture1 is the normal map, with dynamic shadow coords in .texcoord
#texture2 is the dynamic shadow texture, with light vectors in .texcoord
#texture3 is the 3d attenuation texture

PARAM	mulf = {2.0, 2.0, 2.0};
PARAM	subf = {-1.0, -1.0, -1.0};
PARAM	expon = program.env[0];
PARAM	lightColor = program.env[1];

OUTPUT	out = result.color;
TEMP	cbrf, nrml, dcal, attn, temp, dshd, hlfa;

#fetch the textures
TEX	dcal, fragment.texcoord[0], texture[0], 2D;
TEX	nrml, fragment.texcoord[0], texture[1], 2D;
TXP	dshd, fragment.texcoord[1], texture[2], 2D;
TEX	attn, fragment.texcoord[3], texture[3], 3D;

#expand the normal
MAD	nrml, nrml, mulf, subf;
#re-normalize interpolated normal
DP3	temp, nrml, nrml;
RSQ	temp, temp.x;
MUL	nrml, nrml, temp;

#re-normalize interpolated light vector and halfangle
DP3	temp, fragment.texcoord[2], fragment.texcoord[2];
RSQ	temp, temp.x;
MUL	temp, temp.x, fragment.texcoord[2];
DP3	cbrf, fragment.texcoord[4], fragment.texcoord[4];
RSQ	cbrf, cbrf.x;
MUL	cbrf, cbrf.x, fragment.texcoord[4];

DP3	temp, nrml, temp;
DP3	cbrf, nrml, cbrf;

SUB	dshd, 1.0, dshd;

#spec color/exponent
POW_SAT	cbrf, cbrf.r, expon.w;
MUL	cbrf.xyz, cbrf, expon;

MUL	temp, temp, lightColor; #factor in light color
#apply minimum light level
MAX	temp, lightColor.w, temp;
MUL	temp, attn, temp; #factor in attenuation
MUL	temp, dshd, temp; #factor in dynamic shadows and add spec

MUL	cbrf, temp, cbrf;

MUL	temp, fragment.color, temp; #factor in ambient color
MAD_SAT	temp, dcal, temp, cbrf; #factor in decal and add spec

MOV	temp.a, dcal.a; #set alpha component by decal

MOV	out, temp;

END
